'use strict';Object.defineProperty(exports,'__esModule',{value:true});var windHttp=require('wind-http'),fetch=require('node-fetch');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var fetch__default=/*#__PURE__*/_interopDefaultLegacy(fetch);function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn) {
  var module = { exports: {} };
	return fn(module, module.exports), module.exports;
}var classCallCheck = createCommonjsModule(function (module) {
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports;
});
var _classCallCheck = /*@__PURE__*/getDefaultExportFromCjs(classCallCheck);var _typeof_1 = createCommonjsModule(function (module) {
  function _typeof(o) {
    "@babel/helpers - typeof";

    return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
      return typeof o;
    } : function (o) {
      return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
    }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(o);
  }
  module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;
});var toPrimitive_1 = createCommonjsModule(function (module) {
  var _typeof = _typeof_1["default"];
  function toPrimitive(t, r) {
    if ("object" != _typeof(t) || !t) return t;
    var e = t[Symbol.toPrimitive];
    if (void 0 !== e) {
      var i = e.call(t, r || "default");
      if ("object" != _typeof(i)) return i;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return ("string" === r ? String : Number)(t);
  }
  module.exports = toPrimitive, module.exports.__esModule = true, module.exports["default"] = module.exports;
});var toPropertyKey_1 = createCommonjsModule(function (module) {
  var _typeof = _typeof_1["default"];
  function toPropertyKey(t) {
    var i = toPrimitive_1(t, "string");
    return "symbol" == _typeof(i) ? i : i + "";
  }
  module.exports = toPropertyKey, module.exports.__esModule = true, module.exports["default"] = module.exports;
});var createClass = createCommonjsModule(function (module) {
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, toPropertyKey_1(descriptor.key), descriptor);
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }
  module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports;
});
var _createClass = /*@__PURE__*/getDefaultExportFromCjs(createClass);var defineProperty = createCommonjsModule(function (module) {
  function _defineProperty(obj, key, value) {
    key = toPropertyKey_1(key);
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;
});
var _defineProperty = /*@__PURE__*/getDefaultExportFromCjs(defineProperty);function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
// RequestInit prop names
var REQUEST_INIT_ATTRIBUTE_NAMES = ["referrer", "referrerPolicy", "mode", "credentials", "redirect", "cache", "integrity", "keepalive"];
/**
 *  node http request adapter
 */
var NodeHttpAdapter = /*#__PURE__*/function () {
  /**
   * @param timeout  default 1min
   * @param defaultOptions
   * @param consumes  default 'application/json;charset=UTF-8'
   */
  function NodeHttpAdapter(timeout, defaultOptions, _consumes) {
    var _this = this;
    _classCallCheck(this, NodeHttpAdapter);
    _defineProperty(this, "timeout", void 0);
    _defineProperty(this, "defaultOptions", void 0);
    _defineProperty(this, "consumes", void 0);
    _defineProperty(this, "send", function (request, context) {
      return new Promise(function (resolve, reject) {
        var result = fetch__default['default'](_this.buildRequest(request)).then(_this.convertResponse)["catch"](function (response) {
          var headers = response.headers,
            ok = response.ok,
            status = response.status,
            statusText = response.statusText;
          return Promise.reject({
            data: response,
            headers: headers,
            ok: ok,
            statusText: statusText,
            statusCode: status
          });
        });
        // 超时控制
        var timeId = setTimeout(function () {
          //丢弃请求
          console.log("browser fetch adapter request timeout", request);
          reject({
            status: 502,
            headers: null,
            data: null,
            ok: false,
            statusText: "request timeout"
          });
        }, context.timeout || _this.timeout);
        result.then(resolve)["catch"](reject)["finally"](function () {
          //清除定时器
          clearTimeout(timeId);
        });
      });
    });
    _defineProperty(this, "convertResponse", function (resp) {
      var headers = resp.headers,
        ok = resp.ok,
        status = resp.status,
        statusText = resp.statusText;
      return _this.parseResponse(resp).then(function (responeBody) {
        return {
          data: responeBody,
          headers: headers,
          ok: ok,
          statusText: statusText,
          statusCode: status
        };
      });
    });
    /**
     * parse response data
     * @param response
     * @return {any}
     */
    _defineProperty(this, "parseResponse", function (response) {
      var getHeaderByName = _this.getHeaderByName,
        consumes = _this.consumes;
      var headers = response.headers;
      if (response.body == null) {
        // 没有响应 body 为null
        if (response.ok) {
          return Promise.resolve();
        }
      }
      // Transfer-Encoding：chunked 情况下没有Content-length请求头
      if (!_this.hasTransferEncoding(headers)) {
        /**
         *  在跨域的情况下需要加以下响应的请求头到，不然无法读取到content length
         *  response.addHeader("Access-Control-Allow-Headers", "Content-Type,Content-Length");
         *  response.addHeader("Access-Control-Expose-Headers","Content-Type,Content-Length");
         */
        var contentLength = parseInt(getHeaderByName(headers, windHttp.CONTENT_LENGTH_HEAD_NAME));
        // 降级模式
        var responseBodyIsEmpty = contentLength === 0; // || Object.is(contentLength, NaN);
        if (responseBodyIsEmpty) {
          return Promise.resolve();
        }
      }
      var responseMediaType = getHeaderByName(headers, windHttp.CONTENT_TYPE_HEAD_NAME) || consumes;
      if (responseMediaType == null) {
        // 未知的 Content-Type  尝试做 json 解析
        return _this.parseJSON(response)["catch"](function (error) {
          console.warn("Content-Type unknown,try parseJSON failure", error);
          return Promise.resolve(response);
        });
      }
      var responseHeaders = _defineProperty({}, windHttp.CONTENT_TYPE_HEAD_NAME, responseMediaType);
      if (windHttp.responseIsJson(responseHeaders)) {
        return _this.parseJSON(response);
      } else if (windHttp.responseIsText(responseHeaders)) {
        return _this.parseText(response);
      } else {
        if (windHttp.responseIsFile(_objectSpread(_objectSpread({}, responseHeaders), {}, _defineProperty({}, windHttp.CONTENT_TRANSFER_ENCODING_HEAD_NAME, getHeaderByName(headers, windHttp.CONTENT_TRANSFER_ENCODING_HEAD_NAME))))) {
          return _this.paresArrayBuffer(response);
        } else {
          return Promise.resolve(response);
        }
      }
    });
    _defineProperty(this, "parseJSON", function (response) {
      return response.json();
    });
    _defineProperty(this, "parseText", function (response) {
      return response.text();
    });
    _defineProperty(this, "paresArrayBuffer", function (response) {
      return response.arrayBuffer();
    });
    _defineProperty(this, "getHeaderByName", function (headers, name) {
      return headers.get(name) || headers.get(name.toLowerCase());
    });
    /**
     * http Transfer-Encoding
     * @param headers
     */
    _defineProperty(this, "hasTransferEncoding", function (headers) {
      var name = 'Transfer-Encoding';
      var value = headers.get(name) || headers.get(name.toLowerCase());
      return value === "chunked";
    });
    this.timeout = timeout !== null && timeout !== void 0 ? timeout : 60 * 1000;
    this.defaultOptions = defaultOptions !== null && defaultOptions !== void 0 ? defaultOptions : {};
    this.consumes = _consumes;
  }
  return _createClass(NodeHttpAdapter, [{
    key: "buildRequest",
    value:
    /**
     * build http request
     * @param  request
     * @return {Request}
     */
    function buildRequest(request) {
      var url = request.url,
        method = request.method,
        headers = request.headers,
        body = request.body;
      if (headers != null && windHttp.matchMediaType(headers[windHttp.CONTENT_TYPE_HEAD_NAME], windHttp.HttpMediaType.MULTIPART_FORM_DATA)) {
        // remove content-type
        // @see {@link https://segmentfault.com/a/1190000010205162}
        delete headers[windHttp.CONTENT_TYPE_HEAD_NAME];
      }
      var reqMethod = windHttp.HttpMethod[method];
      // build RequestInit
      var requestInit = _objectSpread(_objectSpread({}, this.defaultOptions), {}, {
        method: reqMethod,
        headers: headers,
        body: body
      });
      REQUEST_INIT_ATTRIBUTE_NAMES.forEach(function (name) {
        var attr = request[name];
        if (attr == null) {
          return;
        }
        requestInit[name] = attr;
      });
      return new fetch.Request(url, requestInit);
    }
  }]);
}();exports.NodeHttpAdapter=NodeHttpAdapter;